"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
/* eslint no-param-reassign: 0 */
var react_1 = __importDefault(require("react"));
var context_1 = __importDefault(require("./src/search/context"));
var statelessOp_1 = __importDefault(require("./statelessOp"));
var ToolkitContext = react_1["default"].createContext({
  searchProps: {
    searchText: "",
    onSearch: function onSearch(val) {},
    onClear: function onClear() {}
  },
  csvProps: {
    onExport: function onExport() {}
  },
  columnToggleProps: {
    columns: [],
    toggles: [],
    onColumnToggle: function onColumnToggle(dataField) {}
  },
  baseProps: {
    keyField: undefined,
    columns: [],
    data: [],
    bootstrap4: undefined
  }
});
var ToolkitProvider = /*#__PURE__*/function (_ref) {
  _inherits(ToolkitProvider, _ref);
  var _super = _createSuper(ToolkitProvider);
  function ToolkitProvider(props) {
    var _this;
    _classCallCheck(this, ToolkitProvider);
    _this = _super.call(this, props);
    var initialState = {
      columnToggle: {},
      searchText: _typeof(props.search) === "object" ? props.search.defaultSearch || "" : ""
    };
    _this._ = null;
    _this.onClear = _this.onClear.bind(_assertThisInitialized(_this));
    _this.onSearch = _this.onSearch.bind(_assertThisInitialized(_this));
    _this.onColumnToggle = _this.onColumnToggle.bind(_assertThisInitialized(_this));
    _this.setDependencyModules = _this.setDependencyModules.bind(_assertThisInitialized(_this));
    if (props.columnToggle) {
      initialState.columnToggle = props.columns.reduce(function (obj, column) {
        obj[column.dataField] = !column.hidden;
        return obj;
      }, {});
    }
    initialState.searchText = _typeof(props.search) === "object" ? props.search.defaultSearch || "" : "";
    _this.state = initialState;
    return _this;
  }
  _createClass(ToolkitProvider, [{
    key: "onSearch",
    value: function onSearch(searchText) {
      if (searchText !== this.state.searchText) {
        this.setState({
          searchText: searchText
        });
      }
    }
  }, {
    key: "onClear",
    value: function onClear() {
      this.setState({
        searchText: ""
      });
    }
  }, {
    key: "onColumnToggle",
    value: function onColumnToggle(dataField) {
      var columnToggle = this.state.columnToggle;
      columnToggle[dataField] = !columnToggle[dataField];
      this.setState(Object.assign(Object.assign({}, this.state), {
        columnToggle: columnToggle
      }));
    }
    /**
     *
     * @param {*} _
     * this function will be called only one time when table render
     * react-bootstrap-table-nextgen/src/context/index.js will call this cb for passing the _ module
     * Please consider to extract a common module to handle _ module.
     * this is just a quick fix
     */
  }, {
    key: "setDependencyModules",
    value: function setDependencyModules(_) {
      this._ = _;
    }
  }, {
    key: "render",
    value: function render() {
      var _a, _b, _c;
      var baseProps = {
        keyField: this.props.keyField,
        columns: this.props.columns,
        data: this.props.data,
        search: (_a = this.props.search) !== null && _a !== void 0 ? _a : false,
        exportCSV: (_b = this.props.exportCSV) !== null && _b !== void 0 ? _b : false,
        bootstrap4: (_c = this.props.bootstrap4) !== null && _c !== void 0 ? _c : false,
        children: this.props.children,
        setDependencyModules: this.setDependencyModules,
        registerExposedAPI: this.registerExposedAPI
      };
      if (this.props.search) {
        baseProps.search = {
          searchContext: (0, context_1["default"])(this.props.search),
          searchText: this.state.searchText
        };
      }
      if (this.props.columnToggle) {
        baseProps.columnToggle = {
          toggles: this.state.columnToggle
        };
      }
      return react_1["default"].createElement(ToolkitContext.Provider, {
        value: {
          searchProps: {
            searchText: this.state.searchText,
            onSearch: this.onSearch,
            onClear: this.onClear
          },
          csvProps: {
            onExport: this.handleExportCSV
          },
          columnToggleProps: {
            columns: this.props.columns,
            toggles: this.state.columnToggle,
            onColumnToggle: this.onColumnToggle
          },
          baseProps: baseProps
        }
      }, this.props.children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var currColumnToggle = state.columnToggle;
      var propsColumnToggle;
      if (props.columnToggle) {
        propsColumnToggle = props.columns.reduce(function (obj, column) {
          obj[column.dataField] = !column.hidden;
          return obj;
        }, {});
      } else {
        propsColumnToggle = {};
      }
      if (currColumnToggle) {
        return Object.assign(Object.assign({}, state), {
          currColumnToggle: currColumnToggle
        });
      } else {
        return Object.assign(Object.assign({}, state), {
          propsColumnToggle: propsColumnToggle
        });
      }
    }
  }]);
  return ToolkitProvider;
}((0, statelessOp_1["default"])(react_1["default"].Component));
exports["default"] = {
  Provider: ToolkitProvider,
  Consumer: ToolkitContext.Consumer
};