"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importDefault(require("react"));
var ToggleList = function ToggleList(_ref) {
  var columns = _ref.columns,
    onColumnToggle = _ref.onColumnToggle,
    toggles = _ref.toggles,
    contextual = _ref.contextual,
    className = _ref.className,
    btnClassName = _ref.btnClassName;
  return react_1["default"].createElement("div", {
    className: "btn-group btn-group-toggle ".concat(className),
    "data-toggle": "buttons"
  }, columns.map(function (column) {
    return Object.assign(Object.assign({}, column), {
      toggle: toggles[column.dataField]
    });
  }).map(function (column) {
    return react_1["default"].createElement("button", {
      type: "button",
      key: column.dataField,
      className: "".concat(btnClassName, " btn btn-").concat(contextual, " ").concat(column.toggle ? "active" : ""),
      "data-toggle": "button",
      "aria-pressed": column.toggle ? "true" : "false",
      onClick: function onClick() {
        return onColumnToggle(column.dataField);
      }
    }, column.text);
  }));
};
ToggleList.propTypes = {
  columns: prop_types_1["default"].array.isRequired,
  toggles: prop_types_1["default"].object.isRequired,
  onColumnToggle: prop_types_1["default"].func.isRequired,
  btnClassName: prop_types_1["default"].string,
  className: prop_types_1["default"].string,
  contextual: prop_types_1["default"].string
};
ToggleList.defaultProps = {
  btnClassName: "",
  className: "",
  contextual: "primary"
};
exports["default"] = ToggleList;